/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package nrfupdate;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 *
 * @author odroid
 */
public class NRFUpdate /*implements Runnable*/ {

    public static Process process;
    public static List<String> jlinkLines;

    public static int masterSTDataAddress = 0;

    public static void main(String[] args) {

        try {

            long start = System.currentTimeMillis();
            System.out.println("top of main in NRFUpdate");
            int loopCount = 0;
            boolean done = false;
            while (!done) {
                try {
                    masterSTDataAddress = 0;
                    loopCount++;
                    System.out.println("top of loop: " + loopCount);
                    
                    // all the master and read/save bs is done outside. this is the main loop that runs forever and turns leds on and off. 
                    // next question, after the head, is whether to build flashlight schematics, figure out rst (later), or figure out gpio for this thing?
                    
                    
                    // why not just try to fix it and if you get a failure oh well. 
                    
                    if( fixLight() ){
                        System.out.println("succeeded fixing the light");
                    } else {
                        System.out.println("failed fixing the light");
                    }
                    
                    
                    System.out.println("bottom of loop: " + loopCount);
                    Thread.sleep(2000);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }

            System.out.println("bottom of main in NRFUpdate: " + (System.currentTimeMillis() - start));

        } catch (Exception e) {
            e.printStackTrace();
        }
        System.out.println("bottom of main in NRFUpdate: " + (new Date()).toString());
    }

    /*
    private void readEntireChipButtonActionPerformed(java.awt.event.ActionEvent evt) {                                                     
    private void readSDAndProgramButtonActionPerformed(java.awt.event.ActionEvent evt) {                                                       
    private void readConfigPagesButtonActionPerformed(java.awt.event.ActionEvent evt) {                                                      
    private void writeEntireButtonActionPerformed(java.awt.event.ActionEvent evt) {                                                  
    private void verifyFixedButtonActionPerformed(java.awt.event.ActionEvent evt) {                                                  
    private void fixLightButtonActionPerformed(java.awt.event.ActionEvent evt) {                                               
     */
    public static boolean readEntireChip() throws Exception {
        return runJLink("scripts/readentire.txt", 40, "bytes from addr 0x00000000 into file...O.K.", 43, "Script processing completed.");
    }

    public static boolean writeMasterSTData() throws Exception {
        String fn = "writemasterstdata" + Integer.toHexString(masterSTDataAddress).toUpperCase() + ".txt";
        return runJLink("scripts/" + fn, 43, "O.K.", 46, "Script processing completed.");
    }

    public static boolean saveMasterSTData() throws Exception {

        // locate reads from chip to all the blocks. this is not protected. 
        // save takes the file
        // save master gets the blocks, locates st address, then reads st directly into the master bin
        // return runJLink("scripts/savemasterstdata.txt", 0, "bytes from addr 0x00000000 into file...O.K.", 0, "Script processing completed.");
        if (masterSTDataAddress > 0) {
            String fn = "page" + Integer.toHexString(masterSTDataAddress).toUpperCase() + ".bin";
            File f = new File(fn);
            if (f.renameTo(new File("masterstdata.bin"))) {
                System.out.println("renamed " + fn + " to masterstdata.bin");
                return true;
            }
        } else {
            System.out.println("no masterSTDataAddress avaialble");
        }
        return false;

    }

    public static boolean detectALM() throws Exception {
        return runJLink("scripts/detect.txt", 33, "Cortex-M0 identified.", 40, "Script processing completed.");
    }

    public static boolean readSDAndProgram() throws Exception {
        return runJLink("scripts/readsdandprogram.txt", 40, "bytes from addr 0x00000000 into file...O.K.", 43, "Script processing completed.");
    }

    public static boolean readConfigPages() throws Exception {
        return runJLink("scripts/readconfigpages.txt", 52, "Reading 1024 bytes from addr 0x0003F000 into file...O.K.", 55, "Script processing completed.");
    }

    public static boolean writeEntire() throws Exception {
        return runJLink("scripts/writeentire.txt", 39, "Downloading file [entirechip.bin]...", 40, "O.K.", 42, "Skipped. Contents already match", 46, "O.K.");

    }

    public static boolean eraseEntire() throws Exception {
        return runJLink("scripts/eraseentire.txt", 44, "Erasing done.", 47, "Script processing completed.");

    }

    public static boolean verifyFixed() throws Exception {
         if (!verifySDAndProgram()) {
            System.out.println("verifyFixed, and verifySDAndProgram failed.");
            return false;
        }
        if (!verifySTPage()) {
            System.out.println("verifyFixed, and writeSDAndProgram succeeded, but verifySTPage failed.");
            return false;
        }
        return true;
    }

    public static boolean fixLight() throws Exception {

        // the shortest would be to...
        //    write sd and program
        //    locate st page
        //    write st page
        //    verify sd and program
        //    verify st page
        if (!locateSTData()) {
            System.out.println("fixLight, and writeSDAndProgram succeeded, but locateSTData failed.");
            return false;
        }
        
        if (!writeSDAndProgram()) {
            System.out.println("fixLight, and writeSDAndProgram failed");
            return false;
        }
        if (!writeMasterSTData()) {
            System.out.println("fixLight, and writeSDAndProgram succeeded, and locateSTData succeeded, but writeMasterSTData failed.");
            return false;
        }
        if (!verifyFixed()) {
            System.out.println("fixLight, and writeSDAndProgram succeeded, and locateSTData succeeded, and writeMasterSTData succeeded, but verifyFixed failed.");
            return false;
        }
       
        return true;

    }

    public static boolean writeSDAndProgram() throws Exception {
        return runJLink("scripts/writesdandprogram.txt", 43, "Verifying flash   [100%] Done.", 49, "Script processing completed.", 46, "O.K.");

    }

    public static boolean locateSTData() throws Exception {
        if (!readConfigPages()) {
            return false;
        }
        int[] addresses = {0x3e000, 0x3e400, 0x3e800, 0x3ec00, 0x3f000};
        List<String> fns = new ArrayList<String>();
        List<Integer> stDatas = new ArrayList<Integer>();
        for (int i = 0; i < addresses.length; i++) {
            String fn = "page" + Integer.toHexString(addresses[i]).toUpperCase() + ".bin";
            fns.add(fn);
            int[] fbs = getFileBytes(fn);

            if ((fbs[0] & 0xf) == 3 && fbs[1] == 0xA1 && fbs[2] == 0x6D && fbs[3] == 0xCF) {
                stDatas.add(i);
            }
        }

        if (stDatas.size() == 1) {
            int stDataIndex = stDatas.get(0);
            System.out.println("found st page at index: " + stDataIndex + ", addr: " + Integer.toHexString(addresses[stDataIndex]).toUpperCase() + ", fn: " + fns.get(stDataIndex));
            masterSTDataAddress = addresses[stDataIndex];
            return true;
            // and this is all we have to know because if this is not zero it means that we have the file and the location
            // so just write it. 
        } else {
            System.out.println("wrong number of maching pages: " + stDatas.size());

        }
        return false;
    }

    public static boolean fixSTData() throws Exception {
        if (!locateSTData()) {
            System.out.println("fixSTData, and locateSTData failed");
            return false;
        }
        if (!writeMasterSTData()) {
            System.out.println("fixSTData, and locateSTData succeeded, but writeMasterSTData failed.");
            return false;
        }
        if (!verifySTPage()) {
            System.out.println("fixSTData, and locateSTData succeeded, and writeMasterSTData succeeded, but verifySTPage failed.");
            return false;
        }
        return true;
    }

    public static boolean verifyEntire() throws Exception {
        return runJLink("scripts/verifyentire.txt", 41, "Verify successful.", 44, "Script processing completed.");
    }

    public static boolean verifySDAndProgram() throws Exception {
        return runJLink("scripts/verifysdandprogram.txt", 41, "Verify successful.", 44, "Script processing completed.");

    }

    public static boolean verifySTPage() throws Exception {

        String fn = "verifystpage" + Integer.toHexString(masterSTDataAddress).toUpperCase() + ".txt";
        return runJLink("scripts/" + fn, 41, "Verify successful.", 44, "Script processing completed.");

        // return runJLink("scripts/verifystpage.txt", 41, "Verify successful.", 44, "Script processing completed.");
    }

    public static int[] getFileBytes(String fn) throws Exception {
        File f = new File(fn);
        int[] out = new int[(int) f.length()];
        InputStream is = new FileInputStream(f);
        for (int i = 0; i < out.length; i++) {

            out[i] = is.read();
        }
        return out;
    }

    public static boolean runJLink(String commandFile, int checkLine1, String checkLine1Contents, int checkLine2, String checkLine2Contents,
            int orLine1, String orLine1Contents, int orLine2, String orLine2Contents) throws Exception {

        jlinkLines = new ArrayList<String>();
        process = Runtime.getRuntime().exec("/home/odroid/JLink_Linux_V616g_arm/JLinkExe -device NRF51822_XXAC -if SWD -AutoConnect 1 -speed 4000 -CommanderScript " + commandFile);

        BufferedReader br = new BufferedReader(new InputStreamReader(process.getInputStream()));
        String line = br.readLine();
        System.out.println("---------------------------");
        while (line != null) {
            System.out.println("jlink[" + commandFile + "], line[" + jlinkLines.size() + "]: " + line);
            jlinkLines.add(line);
            line = br.readLine();
        }

        if (checkLine1 > 0 && checkLine1 < jlinkLines.size()) {

            String line1 = jlinkLines.get(checkLine1);
            System.out.println("checking line [" + checkLine1 + "][" + checkLine1Contents + "]: " + line1);
            if (line1.contains(checkLine1Contents)) {
                if (checkLine2 > 0 && checkLine2 < jlinkLines.size()) {

                    String line2 = jlinkLines.get(checkLine2);
                    System.out.println("checking line [" + checkLine2 + "][" + checkLine2Contents + "]: " + line2);
                    if (line2.contains(checkLine2Contents)) {
                        System.out.println("OK");
                        return true;
                    }

                } else {
                    System.out.println("OK");
                    return true;
                }
            }

        } else if (checkLine1 > 0) {
            System.out.println("checkLine1 greater than list size");
            // return;
        } else {
            System.out.println("No line checks, OK");
            return true;
        }

        if (orLine1 > 0 && orLine1 < jlinkLines.size()) {

            String line1 = jlinkLines.get(orLine1);
            System.out.println("checking line [" + orLine1 + "][" + orLine1Contents + "]: " + line1);
            if (line1.contains(orLine1Contents)) {
                System.out.println("OK");
                return true;

            }

        }
        if (orLine2 > 0 && orLine2 < jlinkLines.size()) {

            String line2 = jlinkLines.get(orLine2);
            System.out.println("checking line [" + orLine2 + "][" + orLine2Contents + "]: " + line2);
            if (line2.contains(orLine2Contents)) {
                System.out.println("OK");
                return true;
            }

        }

        System.out.println("FAIL");

        return false;
    }

    public static boolean runJLink(String commandFile, int checkLine1, String checkLine1Contents, int checkLine2, String checkLine2Contents, int orLine, String orLineContents) throws Exception {
        return runJLink(commandFile, checkLine1, checkLine1Contents, checkLine2, checkLine2Contents, orLine, orLineContents, 0, "");
    }

    public static boolean runJLink(String commandFile, int checkLine1, String checkLine1Contents, int checkLine2, String checkLine2Contents) throws Exception {
        return runJLink(commandFile, checkLine1, checkLine1Contents, checkLine2, checkLine2Contents, 0, "");

    }

    public static void delay(long ms) {
        try {
            Thread.sleep(ms);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /*public void run() {

        try {
            BufferedReader br = new BufferedReader(new InputStreamReader(process.getInputStream()));
            String line = br.readLine();
            while (line != null) {
                System.out.println("jlink line[" + jlinkLines.size() + "]: " + line);
                jlinkLines.add(line);
                line = br.readLine();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

    }*/
}
